
object Test {

  def main (argv:Array[String]):Unit = run()

  def run ():Unit = {

    // Lists of Int

    val L1:List[Int] = List.cons(33,List.cons(66,List.cons(99,List.empty())))
    println("L1 = " + L1)
    println("Elements L1 = ")
    Stream.print[Int](L1)

    // Lists of String

    val L2:List[String] = 
      List.cons[String]("hello",
                        List.cons[String]("world",
                                          List.empty[String]))
    println("L2 = " + L2)
    println("Elements L2 = ")
    Stream.print[String](L2)

    // Trees of Int

    val T = BinTree

    val T1:BinTree[Int] = T.node(33,
				 T.node(66,
					T.node(99,T.empty(),T.empty()),
					T.empty()),
				 T.node(11,
					T.node(22,T.empty(),T.empty()),
					T.node(44,T.empty(),T.empty())))
    println("T1 = " + T1)
    println("Elements T1 = ")
    Stream.print(T1)

    // Lists of Int

    val L3:List[Int] = 
      List.cons(33,List.cons(66,List.cons(99,List.empty())))

    println("L3 = " + L3)
    println("Elements L3 = ")
    Stream.print(L3)

    // Lists of AInt

    def i(n:Int):AInt = AInt.create(n)

    val L5:List[AInt] = 
      List.cons(i(33),List.cons(i(66),List.cons(i(99),List.empty())))

    println("L5 = " + L5)
    println("Elements L5 = ")
    Stream.print(L5)
    println("Sum L5 = " + Stream.sum(L5,i(0)))

    // Trees of Pairs of AInts

    val p0:APair[AInt,AInt] = APair.create(i(0),i(0))
    val p1:APair[AInt,AInt] = APair.create(i(1),i(2))
    val p2:APair[AInt,AInt] = APair.create(i(30),i(40))
    val p3:APair[AInt,AInt] = APair.create(i(500),i(600))
    val p4:APair[AInt,AInt] = APair.create(i(7000),i(8000))
    
    val T3:BinTree[APair[AInt,AInt]] =
      T.node(p1,
	     T.node(p2,T.empty(),T.empty()),
	     T.node(p3,
		    T.node(p4,
			   T.empty(), T.empty()),
		    T.empty()))
    println("T3 = " + T3)
    println("Elements T3 = ")
    Stream.print(T3)
    println("Sum T3 = " + Stream.sum(T3,p0))

    // working with more interesting pairs

    val pp0:APair[AInt,APair[AInt,AInt]] = APair.create(i(0),p0)
    val pp1:APair[AInt,APair[AInt,AInt]] = APair.create(i(1),p1)
    val pp2:APair[AInt,APair[AInt,AInt]] = APair.create(i(2),p2)
    val pp3:APair[AInt,APair[AInt,AInt]] = APair.create(i(3),p3)
    val pp4:APair[AInt,APair[AInt,AInt]] = APair.create(i(4),p4)
    
    val T4:BinTree[APair[AInt,APair[AInt,AInt]]] =
      T.node(pp1,
	     T.node(pp2,T.empty(),T.empty()),
	     T.node(pp3,
		    T.node(pp4,
			   T.empty(), T.empty()),
		    T.empty()))
    println("T4 = " + T4)
    println("Elements T4 = ")
    Stream.print(T4)
    println("Sum T4 = " + Stream.sum(T4,pp0))

    val S = Stream
    val size = 20

    println("--------------------------------------------------")
    println("Elements sequence(T1,L3) = ")
    S.print(S.sequence(T1,L3))

    println("--------------------------------------------------")
    println("Constant(99) = ")
    S.printN(S.constant(99),size)

    println("--------------------------------------------------")
    println("Odds = ")
    S.printN(S.oneOutOfTwo(S.intsFrom(1)),size)

    println("--------------------------------------------------")
    println("Evens = ")
    S.printN(S.oneOutOfTwo(S.intsFrom(2)),size)

    println("--------------------------------------------------")
    println("Zip(Constant(99),IntsFrom(3)) = ")
    S.printN(S.zip(S.constant(99),S.intsFrom(3)),size)

    println("--------------------------------------------------")
    println("Zip(Constant(99),T1) = ")
    S.printN(S.zip(S.constant(99),T1),size)

    println("--------------------------------------------------")
    println("Cartesian(T1,IntsFrom(1)) = ")
    S.printN(S.cartesian(T1,S.intsFrom(1)),size)

    println("--------------------------------------------------")
    println("Squares) = ")
    val squares:Stream[Int] = S.map(S.intsFrom(1),(x:Int)=> x*x)
    S.printN(squares,size)

    println("--------------------------------------------------")
    println("Squares with last digit <= 5) = ")
    S.printN(S.filter(squares, (x:Int)=> (x % 10 <= 5)),size)


    println("--------------------------------------------------")
    println("Primtes = ")
    S.printN(S.sieve(S.intsFrom(2)),size)
    
  }
}
